# -*- coding: utf-8 -*-
"""минимодель.ipynb

Automatically generated by Colab.

Original file is located at
    https://colab.research.google.com/drive/1sysRRQHHHIWFIyKXaMv4KzgJ191K7QKB

### Загрузка датасета с необходимыми параметрами :
-sales_rub - уровень продаж (руб)
-sales_upak	- уровень продаж упаковок (шт)
-disturb - Дистрибуция
-ill_stat	- Статистика заболеваний
-price_ind	- индекс цены
-media_active	- Активность в медиа-пространстве
-djener_disturb	- распространение дженериков
-djener_kolvo - количество дженериков
"""

import pandas as pd
import numpy as np
import matplotlib.pyplot as plt

df = pd.read_excel('hack.xlsx')
df.set_index('date', inplace=True)

df.head()

df.dtypes

df.hist(bins=20, color='pink')

df=df.drop(['sales_upak'], axis = 1)
df

"""### Выявление выбросов, предобработка (нормализация/стандартизация) данных для дальнейшего моделирования."""

df.plot(kind='box', subplots= True, layout= (3,4), sharex= False,sharey= False)

import scipy.stats as stats

#find absolute value of z-score for each observation
z = np.abs(stats.zscore(df))

#only keep rows in dataframe with all z-scores less than absolute value of 3
df = df[(z<3).all(axis=1)]

#find how many rows are left in the dataframe
df.shape

from sklearn import preprocessing
x_array=np.array(df)
normalized_arr=preprocessing.normalize(x_array)
print(normalized_arr)

from sklearn.preprocessing import StandardScaler
scaler = StandardScaler()
scaler.fit(normalized_arr)
scaled_features = scaler.transform(normalized_arr)
scaled_features

scaled_features

a= pd.DataFrame(data=scaled_features)

a.columns = ['sales_rub',	'disturb',	'ill_stat',	'price_ind'	,'media_active'	,'djener_disturb',	'djener_kolvo']

a

"""### Просмотр параметров модели"""

import seaborn as sns
dataplot = sns.heatmap(a.corr(), cmap="YlGnBu", annot=True)

# displaying heatmap
plt.show()

sns.heatmap(a.cov(), cmap="YlGnBu", annot=True)

from patsy import dmatrices
from statsmodels.stats.outliers_influence import variance_inflation_factor

#find design matrix for linear regression model using 'rating' as response variable
y, X = dmatrices('sales_rub ~ disturb+ill_stat+price_ind+ media_active+djener_disturb', data=df, return_type='dataframe')

#calculate VIF for each explanatory variable
vif = pd.DataFrame()
vif['VIF'] = [variance_inflation_factor(X.values, i) for i in range(X.shape[1])]
vif['variable'] = X.columns

#view VIF for each explanatory variable
vif



"""### Выявление наиболее значимых признаков влияющих на уровень продаж"""

feature_names=[	'disturb',	'ill_stat',	'price_ind'	,'media_active'	,'djener_disturb',	'djener_kolvo']

from sklearn.model_selection import train_test_split

X=a[['disturb','ill_stat','price_ind'	,'media_active'	,'djener_disturb','djener_kolvo']]
y=a['sales_rub']

X_train,X_test,y_train,y_test=train_test_split(X,y,test_size=0.3,random_state=85)

from sklearn.ensemble import RandomForestClassifier
from sklearn import metrics
from sklearn import utils
lab = preprocessing. LabelEncoder ()
y_train1 = lab. fit_transform (y_train)

clf=RandomForestClassifier(n_estimators=100)
clf.fit(X_train,y_train1)
feauture_imp=pd.Series(clf.feature_importances_,index=feature_names).sort_values(ascending=False)
print(feauture_imp)


import seaborn as sns


sns.barplot(x=feauture_imp,y=feauture_imp.index)
plt.xlabel('Значимость признаков')
plt.ylabel('признаки')
plt.title('Значимые признаки ')

plt.show()

"""### Используем предиктор для проверки сразу на большое количество регрессионных моделей"""

!pip install lazypredict

import lazypredict

from lazypredict.Supervised import LazyRegressor
from sklearn import datasets
from sklearn.utils import shuffle
import numpy as np


X=a[['disturb','ill_stat','price_ind'	,'media_active'	,'djener_disturb','djener_kolvo']]
y=a['sales_rub']

offset = int(X.shape[0] * 0.9)

X_train, y_train = X[:offset], y[:offset]
X_test, y_test = X[offset:], y[offset:]

reg = LazyRegressor(verbose=0, ignore_warnings=False, custom_metric=None)
models, predictions = reg.fit(X_train, X_test, y_train, y_test)

print(models)

cov = np.cov(df)

